'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.watcherError = exports.watcherDestroy = exports.watcherCopy = undefined;

var _fs = require('./fs');

var watcherCopy = exports.watcherCopy = function watcherCopy(target, options, notify) {
  return function (file) {
    (0, _fs.copy)(file, (0, _fs.resolveTarget)(file, target, options), options, notify);
  };
};

var watcherDestroy = exports.watcherDestroy = function watcherDestroy(target, options, notify) {
  return function (file) {
    (0, _fs.deleteExtra)((0, _fs.resolveTarget)(file, target, options), options, notify);
  };
};

var watcherError = exports.watcherError = function watcherError(options, notify) {
  return function (err) {
    notify('error', err);
  };
};